/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TenantResourceService = (function () {
    function TenantResourceService(Client) {
        this.Client = Client;
    }
    TenantResourceService.prototype.create = function (resource) {
        return this.Client.post(this.getUrl('/'), resource).then(function (response) {
            return response.data.result;
        });
    };
    TenantResourceService.prototype.query = function (query) {
        if (query === void 0) { query = {}; }
        return this.Client.get(this.getUrl('/'), query).then(function (response) {
            return response.data.results;
        });
    };
    TenantResourceService.prototype.get = function (key, query) {
        if (query) {
            return this.Client.post(this.getUrl("/query/" + key), { query: query }).then(function (response) {
                return response.data.result;
            });
        }
        else {
            return this.Client.get(this.getUrl("/item/" + key)).then(function (response) {
                return response.data.result;
            });
        }
    };
    TenantResourceService.prototype.update = function (key, data) {
        return this.Client.post(this.getUrl("/item/" + key), data).then(function (response) {
            return response.data.result;
        });
    };
    TenantResourceService.prototype.remove = function (key) {
        return this.Client.remove(this.getUrl("/item/" + key)).then(function (response) {
            return response.data.result;
        });
    };
    TenantResourceService.prototype.updateField = function (key, field, value) {
        return this.Client.post(this.getUrl("/item/" + key + "/field/" + field), (_a = {}, _a[field] = value, _a)).then(function (response) {
            return response.data.result;
        });
        var _a;
    };
    TenantResourceService.prototype.removeField = function (key, field) {
        return this.Client.remove(this.getUrl("/item/" + key + "/field/" + field)).then(function (response) {
            return response.data.result;
        });
    };
    return TenantResourceService;
}());
exports.TenantResourceService = TenantResourceService;


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = __webpack_require__(2);
var authenticator_1 = __webpack_require__(3);
var authentication_1 = __webpack_require__(4);
var client_1 = __webpack_require__(5);
var user_1 = __webpack_require__(6);
var tenant_1 = __webpack_require__(7);
var user_2 = __webpack_require__(8);
var member_1 = __webpack_require__(9);
var tenant_2 = __webpack_require__(10);
var authorization_1 = __webpack_require__(11);
var member_2 = __webpack_require__(12);
var group_1 = __webpack_require__(13);
var menu_1 = __webpack_require__(14);
var module_1 = __webpack_require__(15);
var user_manager_1 = __webpack_require__(16);
var telegram_1 = __webpack_require__(17);
try {
    var module = angular.module('sw-client', ['ng']);
    var authentication = new authentication_1.Authentication();
    var authorization = new authorization_1.Authorization();
    module.constant('AuthenticationEvent', events_1.AuthenticationEvent);
    module.value('Authentication', authentication);
    module.value('User', new user_2.User(authentication));
    module.value('Authorization', authorization);
    module.value('Tenant', new tenant_2.Tenant(authorization));
    module.value('Member', new member_1.Member(authorization));
    module.provider('Client', client_1.ClientProvider);
    module.provider('AuthenticationEvents', events_1.AuthenticationEventsProvider);
    module.provider('ClientResponseTimeHttpInterceptor', client_1.ClientResponseTimeHttpInterceptor);
    module.provider('Authenticator', authenticator_1.AuthenticatorProvider);
    module.provider('TelegramAuthenticator', telegram_1.TelegramAuthenticatorProvider);
    module.provider('UserService', user_1.UserServiceProvider);
    module.provider('TenantService', tenant_1.TenantServiceProvider);
    module.provider('TenantMemberManager', member_2.TenantMemberManagerProvider);
    module.provider('TenantGroupManager', group_1.TenantGroupManagerProvider);
    module.provider('TenantMenuManager', menu_1.TenantMenuManagerProvider);
    module.provider('TenantModuleManager', module_1.TenantModuleManagerProvider);
    module.provider('UserManager', user_manager_1.UserManagerProvider);
    console.log('sw-client loaded successful');
}
catch (err) {
    console.error('error load sw-client', err);
}


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationEvent = {
    Updated: 'authentication:updated',
    Authenticated: 'authentication:authenticated',
    Authorized: 'authentication::authorized',
    notAuthenticated: 'authentication::not-authorized',
    notAuthorized: 'authentication::forbidden'
};
var AuthenticationEvents = (function () {
    function AuthenticationEvents($rootScope) {
        var _this = this;
        this.$rootScope = $rootScope;
        this.handlers = [];
        var rootScopeDestroyEvent = $rootScope.$on('$destroy', function () {
            _this.handlers.map(function (handler) { return handler(); });
            rootScopeDestroyEvent();
        });
    }
    AuthenticationEvents.prototype.Updated = function (context) {
        this.$rootScope.$emit(exports.AuthenticationEvent.Updated, context);
    };
    AuthenticationEvents.prototype.Authenticated = function (context) {
        this.$rootScope.$emit(exports.AuthenticationEvent.Authenticated, context);
    };
    AuthenticationEvents.prototype.AuthenticationFailed = function (context) {
        this.$rootScope.$emit(exports.AuthenticationEvent.notAuthenticated, context);
    };
    AuthenticationEvents.prototype.Authorized = function (context) {
        this.$rootScope.$emit(exports.AuthenticationEvent.Authorized, context);
    };
    AuthenticationEvents.prototype.AuthorizationFailed = function (context) {
        this.$rootScope.$emit(exports.AuthenticationEvent.notAuthorized, context);
    };
    AuthenticationEvents.prototype.OnUpdated = function (handler) {
        this.handlers.push(this.$rootScope.$on(exports.AuthenticationEvent.Updated, handler));
    };
    AuthenticationEvents.prototype.OnAuthenticated = function (handler) {
        this.handlers.push(this.$rootScope.$on(exports.AuthenticationEvent.Authenticated, handler));
    };
    AuthenticationEvents.prototype.OnAuthenticationFailed = function (handler) {
        this.handlers.push(this.$rootScope.$on(exports.AuthenticationEvent.notAuthenticated, handler));
    };
    AuthenticationEvents.prototype.OnAuthorized = function (handler) {
        this.handlers.push(this.$rootScope.$on(exports.AuthenticationEvent.Authorized, handler));
    };
    AuthenticationEvents.prototype.OnAuthorizationFailed = function (handler) {
        this.handlers.push(this.$rootScope.$on(exports.AuthenticationEvent.notAuthorized, handler));
    };
    return AuthenticationEvents;
}());
exports.AuthenticationEvents = AuthenticationEvents;
var AuthenticationEventsProvider = (function () {
    function AuthenticationEventsProvider() {
    }
    AuthenticationEventsProvider.prototype.$get = function ($rootScope) {
        if (!this.events) {
            this.events = new AuthenticationEvents($rootScope);
        }
        return this.events;
    };
    ;
    return AuthenticationEventsProvider;
}());
exports.AuthenticationEventsProvider = AuthenticationEventsProvider;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Authenticator = (function () {
    function Authenticator(client, AuthenticationEvents, Authentication, User) {
        this.client = client;
        this.AuthenticationEvents = AuthenticationEvents;
        this.Authentication = Authentication;
        this.User = User;
    }
    Object.defineProperty(Authenticator.prototype, "IsInitialized", {
        get: function () {
            return this.Authentication.IsInitialized;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authenticator.prototype, "IsAuthenticated", {
        get: function () {
            return this.Authentication.IsAuthenticated;
        },
        enumerable: true,
        configurable: true
    });
    Authenticator.prototype.GetStatus = function () {
        var _this = this;
        var payload = {};
        return this.client.post('/api/auth/status', payload)
            .then(function (response) {
            return _this.update(response.data.result);
        }, function (err) {
            _this.Authentication.Reset();
            throw err;
        });
    };
    Authenticator.prototype.Register = function (type, name, password, displayName, code) {
        var _this = this;
        var payload = {
            name: name,
            password: password,
            displayName: displayName,
            code: code
        };
        return this.client.post("/api/auth/" + type + "/register", payload)
            .then(function (response) {
            _this.update(response.data.result);
            if (_this.Authentication.IsAuthenticated) {
                _this.AuthenticationEvents.Authenticated(_this.Authentication);
            }
            return _this.Authentication;
        }, function (err) {
            _this.Authentication.Reset();
            throw err;
        });
    };
    Authenticator.prototype.Resend = function (type, name) {
        var _this = this;
        var payload = {
            name: name
        };
        return this.client.post("/api/auth/" + type + "/resend", payload)
            .then(function (response) {
            return _this.update(response.data.result);
        }, function (err) {
            _this.Authentication.Reset();
            throw err;
        });
    };
    Authenticator.prototype.Verify = function (type, code) {
        var _this = this;
        var payload = {
            code: code
        };
        return this.client.post("/api/auth/" + type + "/verify", payload)
            .then(function (response) {
            _this.update(response.data.result);
            if (_this.Authentication.IsAuthenticated) {
                _this.AuthenticationEvents.Authenticated(_this.Authentication);
            }
            return _this.Authentication;
        }, function (err) {
            _this.Authentication.Reset();
            throw err;
        });
    };
    Authenticator.prototype.Login = function (type, name, password) {
        var _this = this;
        var payload = {
            name: name,
            password: password
        };
        return this.client.post("/api/auth/" + type + "/login", payload)
            .then(function (response) {
            _this.update(response.data.result);
            if (_this.Authentication.IsAuthenticated) {
                _this.AuthenticationEvents.Authenticated(_this.Authentication);
            }
            return _this.Authentication;
        }, function (err) {
            _this.Authentication.Reset();
            throw err;
        });
    };
    Authenticator.prototype.Impersonate = function (uid) {
        return this.client.post("/api/admin/user/" + uid + "/impersonate").then(function (response) {
            return response.data.result;
        });
    };
    Authenticator.prototype.StopImpersonate = function () {
        return this.client.post("/api/my/impersonate").then(function (response) {
            return response.data.result;
        });
    };
    Authenticator.prototype.Logout = function () {
        var _this = this;
        var payload = {};
        return this.client.post('/api/auth/logout', payload)
            .then(function (result) {
            _this.update(null);
            return result.data;
        }, function (err) {
            _this.Authentication.Reset();
            throw err;
        });
    };
    Authenticator.prototype.update = function (status) {
        this.Authentication.Update(status);
        this.AuthenticationEvents.Updated(this.Authentication);
        return this.Authentication;
    };
    return Authenticator;
}());
exports.Authenticator = Authenticator;
var AuthenticatorProvider = (function () {
    function AuthenticatorProvider() {
    }
    AuthenticatorProvider.prototype.$get = function (Client, AuthenticationEvents, Authentication, User) {
        return new Authenticator(Client, AuthenticationEvents, Authentication, User);
    };
    ;
    return AuthenticatorProvider;
}());
exports.AuthenticatorProvider = AuthenticatorProvider;


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Authentication = (function () {
    function Authentication() {
        this.version = null;
        this.status = null;
    }
    Object.defineProperty(Authentication.prototype, "IsInitialized", {
        get: function () {
            return !!this.version;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authentication.prototype, "IsAuthenticated", {
        get: function () {
            return !!(this.status && this.status.user);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authentication.prototype, "Version", {
        get: function () {
            return this.version;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authentication.prototype, "Token", {
        get: function () {
            return this.status && this.status.identity ? this.status.identity.token : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authentication.prototype, "Roles", {
        get: function () {
            return this.status && this.status.identity ? this.status.identity.allows : [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authentication.prototype, "IsAdmin", {
        get: function () {
            return this.HasRole('admin');
        },
        enumerable: true,
        configurable: true
    });
    Authentication.prototype.HasRole = function (role) {
        return !!~this.Roles.indexOf(role);
    };
    Object.defineProperty(Authentication.prototype, "Status", {
        get: function () {
            return this.status;
        },
        enumerable: true,
        configurable: true
    });
    Authentication.prototype.Update = function (status) {
        this.version = (status && status.version) ? status.version : this.version;
        this.status = status;
        return this;
    };
    Authentication.prototype.Reset = function () {
        this.status = null;
        return this;
    };
    return Authentication;
}());
exports.Authentication = Authentication;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Client = (function () {
    function Client($http, Authentication, AuthenticationEvents, baseUrl) {
        if (baseUrl === void 0) { baseUrl = ''; }
        this.$http = $http;
        this.Authentication = Authentication;
        this.AuthenticationEvents = AuthenticationEvents;
        this.baseUrl = baseUrl;
    }
    Client.prototype.post = function (url, data) {
        if (data === void 0) { data = {}; }
        return this.request({
            method: 'POST',
            url: this.getUrl(url),
            data: data
        });
    };
    Client.prototype.put = function (url, data) {
        return this.request({
            method: 'PUT',
            url: this.getUrl(url),
            data: data
        });
    };
    Client.prototype.get = function (url, params) {
        return this.request({
            method: 'GET',
            url: this.getUrl(url),
            params: params
        });
    };
    Client.prototype.remove = function (url, data) {
        return this.request({
            method: 'DELETE',
            url: this.getUrl(url),
            data: data
        });
    };
    Client.prototype.request = function (config) {
        var _this = this;
        var token = this.Authentication.Token;
        config.headers = config.headers || {};
        if (token) {
            config.headers['USER-TOKEN'] = token;
        }
        return this.$http(config).then(function (response) {
            if (!response.data.ok) {
                throw new HttpError(response);
            }
            return response;
        }, function (errorResponse) {
            if (errorResponse.status === 401) {
                _this.AuthenticationEvents.AuthenticationFailed(errorResponse);
                _this.Authentication.Reset();
            }
            else if (errorResponse.status === 403) {
                _this.AuthenticationEvents.AuthorizationFailed(errorResponse);
            }
            throw new HttpError(errorResponse);
        });
    };
    Client.prototype.getUrl = function (endpoint) {
        return "" + this.baseUrl + endpoint;
    };
    return Client;
}());
exports.Client = Client;
var HttpError = (function (_super) {
    __extends(HttpError, _super);
    function HttpError(response) {
        var _this = _super.call(this, response.data && response.data.message ? response.data.message + " (" + response.data.errcode + ")" : response.statusText + " [" + response.status + "]") || this;
        _this.status = response.status;
        _this.statusText = response.statusText;
        _this.headers = response.headers;
        _this.data = response.data;
        return _this;
    }
    return HttpError;
}(Error));
exports.HttpError = HttpError;
var ClientProvider = (function () {
    function ClientProvider() {
    }
    ClientProvider.prototype.setBaseUrl = function (baseUrl) {
        this.baseUrl = baseUrl;
    };
    ClientProvider.prototype.$get = function ($http, Authentication, AuthenticationEvents) {
        if (angular.mock) {
            var $injector = angular.injector(['ng']);
            $http = $injector.get('$http');
        }
        return new Client($http, Authentication, AuthenticationEvents, this.baseUrl);
    };
    ;
    return ClientProvider;
}());
exports.ClientProvider = ClientProvider;
var ClientResponseTimeHttpInterceptor = (function () {
    function ClientResponseTimeHttpInterceptor() {
    }
    ClientResponseTimeHttpInterceptor.prototype.$get = function ($log) {
        return {
            request: function (config) {
                config['ResponseTimeClient'] = Date.now();
                return config;
            },
            response: function (response) {
                response.config['ResponseTimeClient'] = Date.now() - response.config['ResponseTimeClient'];
                if (response.config.url.indexOf('.htm') < 0 && response.config.url.indexOf('.json') < 0) {
                    $log.log(response.config['ResponseTimeClient'] + "ms (server: " + response.headers('x-response-time') + ") " + response.config.url);
                }
                return response;
            },
        };
    };
    ;
    return ClientResponseTimeHttpInterceptor;
}());
exports.ClientResponseTimeHttpInterceptor = ClientResponseTimeHttpInterceptor;


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var UserServiceProvider = (function () {
    function UserServiceProvider() {
    }
    UserServiceProvider.prototype.$get = function (Client) {
        return new UserService(Client);
    };
    ;
    return UserServiceProvider;
}());
exports.UserServiceProvider = UserServiceProvider;
var UserService = (function () {
    function UserService(Client) {
        this.Client = Client;
    }
    UserService.prototype.GetMyAccounts = function () {
        return this.Client.get('/api/my/account/search')
            .then(function (response) { return response.data.results; });
    };
    UserService.prototype.CreateMyAccount = function (payload) {
        return this.Client.post('/api/my/account/create', payload)
            .then(function (response) { return response.data.result; });
    };
    UserService.prototype.GetAccountDetails = function (account) {
        return this.Client.get("/api/my/account/summary/" + account)
            .then(function (response) { return response.data.result; });
    };
    UserService.prototype.JoinAccount = function (account, member) {
        if (member === void 0) { member = {}; }
        return this.Client.post('/api/my/account/join', __assign({ account: account }, member))
            .then(function (response) { return response.data.result; });
    };
    return UserService;
}());
exports.UserService = UserService;


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TenantServiceProvider = (function () {
    function TenantServiceProvider() {
    }
    TenantServiceProvider.prototype.$get = function (Client, Authorization) {
        return new TenantService(Client, Authorization);
    };
    ;
    return TenantServiceProvider;
}());
exports.TenantServiceProvider = TenantServiceProvider;
var TenantService = (function () {
    function TenantService(Client, Authorization) {
        this.Client = Client;
        this.Authorization = Authorization;
    }
    TenantService.prototype.getUrl = function (account, path) {
        return "/api/account/" + account + path;
    };
    TenantService.prototype.Authorise = function (account) {
        var _this = this;
        return this.Client.get(this.getUrl(account, '/authorise')).then(function (response) {
            _this.Authorization.Update(response.data.result);
            return response.data;
        }, function (err) {
            _this.Authorization.Reset();
            throw err;
        });
    };
    return TenantService;
}());
exports.TenantService = TenantService;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var User = (function () {
    function User(Authentication) {
        this.Authentication = Authentication;
    }
    Object.defineProperty(User.prototype, "displayName", {
        get: function () {
            var status = this.Authentication.Status;
            return status && status.user ? status.user.displayName : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(User.prototype, "displayImageURL", {
        get: function () {
            var status = this.Authentication.Status;
            return status && status.user ? status.user.displayImageURL : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(User.prototype, "roles", {
        get: function () {
            var status = this.Authentication.Status;
            return status && status.user ? status.user.roles : [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(User.prototype, "settings", {
        get: function () {
            var status = this.Authentication.Status;
            return status && status.user ? status.user.settings : {};
        },
        enumerable: true,
        configurable: true
    });
    User.prototype.hasRole = function (role) {
        var roles = this.roles;
        return Array.isArray(roles) && !!~roles.indexOf(role);
    };
    Object.defineProperty(User.prototype, "isAdmin", {
        get: function () {
            return this.hasRole('admin');
        },
        enumerable: true,
        configurable: true
    });
    return User;
}());
exports.User = User;


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Member = (function () {
    function Member(Authorization) {
        this.Authorization = Authorization;
    }
    Object.defineProperty(Member.prototype, "id", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.member.id : NaN;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Member.prototype, "activated", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.member.activated : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Member.prototype, "displayName", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.member.displayName : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Member.prototype, "displayImageURL", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.member.displayImageURL : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Member.prototype, "title", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.member.title : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Member.prototype, "groups", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.member.groups : [];
        },
        enumerable: true,
        configurable: true
    });
    Member.prototype.hasGroup = function (group) {
        return !!~this.groups.indexOf(group);
    };
    return Member;
}());
exports.Member = Member;


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Tenant = (function () {
    function Tenant(Authorization) {
        this.Authorization = Authorization;
    }
    Object.defineProperty(Tenant.prototype, "name", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.tenant.name : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Tenant.prototype, "displayName", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.tenant.displayName : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Tenant.prototype, "displayImageURL", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.tenant.displayImageURL : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Tenant.prototype, "menus", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.menus : [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Tenant.prototype, "settings", {
        get: function () {
            return this.Authorization.Status ? this.Authorization.Status.settings : {};
        },
        enumerable: true,
        configurable: true
    });
    return Tenant;
}());
exports.Tenant = Tenant;


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Authorization = (function () {
    function Authorization() {
        this.status = null;
    }
    Object.defineProperty(Authorization.prototype, "IsAuthorized", {
        get: function () {
            return !!this.status;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Authorization.prototype, "Status", {
        get: function () {
            return this.status;
        },
        enumerable: true,
        configurable: true
    });
    Authorization.prototype.Update = function (status) {
        this.status = status;
        return this;
    };
    Authorization.prototype.Reset = function () {
        this.status = null;
        return this;
    };
    return Authorization;
}());
exports.Authorization = Authorization;


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var resource_1 = __webpack_require__(0);
var TenantMemberManagerProvider = (function () {
    function TenantMemberManagerProvider() {
    }
    TenantMemberManagerProvider.prototype.$get = function (Client, Authorization, Tenant) {
        return new TenantMemberManager(Client, Authorization, Tenant);
    };
    ;
    return TenantMemberManagerProvider;
}());
exports.TenantMemberManagerProvider = TenantMemberManagerProvider;
var TenantMemberManager = (function (_super) {
    __extends(TenantMemberManager, _super);
    function TenantMemberManager(Client, Authorization, Tenant) {
        var _this = _super.call(this, Client) || this;
        _this.Authorization = Authorization;
        _this.Tenant = Tenant;
        return _this;
    }
    TenantMemberManager.prototype.getUrl = function (path) {
        if (!this.Authorization.IsAuthorized) {
            throw new Error('Not Authorized');
        }
        return "/api/account/" + this.Tenant.name + "/admin/member" + path;
    };
    TenantMemberManager.prototype.findGroups = function (member) {
        return this.Client.get(this.getUrl("/" + member + "/group")).then(function (response) {
            return response.data.results;
        });
    };
    TenantMemberManager.prototype.addGroups = function (member, groups) {
        return this.Client.post(this.getUrl("/" + member + "/group/"), { groups: groups }).then(function (response) {
            return response.data.result;
        });
    };
    TenantMemberManager.prototype.addGroup = function (member, group) {
        return this.Client.post(this.getUrl("/" + member + "/group/" + group)).then(function (response) {
            return response.data.result;
        });
    };
    TenantMemberManager.prototype.getGroup = function (member, group) {
        return this.Client.get(this.getUrl("/" + member + "/group/" + group)).then(function (response) {
            return response.data.result;
        });
    };
    TenantMemberManager.prototype.removeGroup = function (member, group) {
        return this.Client.remove(this.getUrl("/" + member + "/group/" + group)).then(function (response) {
            return response.data.result;
        });
    };
    TenantMemberManager.prototype.findByEmail = function (email) {
        return this.Client.post(this.getUrl("/find_by_email"), { email: email }).then(function (response) {
            return response.data.result;
        });
    };
    TenantMemberManager.prototype.inviteMemberById = function (id) {
        return this.Client.post(this.getUrl("/" + id + "/invite")).then(function (response) {
            return response.data.result;
        });
    };
    return TenantMemberManager;
}(resource_1.TenantResourceService));
exports.TenantMemberManager = TenantMemberManager;


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var resource_1 = __webpack_require__(0);
var TenantGroupManagerProvider = (function () {
    function TenantGroupManagerProvider() {
    }
    TenantGroupManagerProvider.prototype.$get = function (Client, Authorization, Tenant) {
        return new TenantGroupManager(Client, Authorization, Tenant);
    };
    ;
    return TenantGroupManagerProvider;
}());
exports.TenantGroupManagerProvider = TenantGroupManagerProvider;
var TenantGroupManager = (function (_super) {
    __extends(TenantGroupManager, _super);
    function TenantGroupManager(Client, Authorization, Tenant) {
        var _this = _super.call(this, Client) || this;
        _this.Authorization = Authorization;
        _this.Tenant = Tenant;
        return _this;
    }
    TenantGroupManager.prototype.getUrl = function (path) {
        if (!this.Authorization.IsAuthorized) {
            throw new Error('Not Authorized');
        }
        return "/api/account/" + this.Tenant.name + "/admin/group" + path;
    };
    TenantGroupManager.prototype.findMembers = function (group) {
        return this.Client.get(this.getUrl("/" + group + "/member")).then(function (response) {
            return response.data.results;
        });
    };
    TenantGroupManager.prototype.addMember = function (group, member) {
        return this.Client.post(this.getUrl("/" + group + "/member/" + member)).then(function (response) {
            return response.data.result;
        });
    };
    TenantGroupManager.prototype.getMember = function (group, member) {
        return this.Client.get(this.getUrl("/" + group + "/member/" + member)).then(function (response) {
            return response.data.result;
        });
    };
    TenantGroupManager.prototype.removeMember = function (group, member) {
        return this.Client.remove(this.getUrl("/" + group + "/member/" + member)).then(function (response) {
            return response.data.result;
        });
    };
    return TenantGroupManager;
}(resource_1.TenantResourceService));
exports.TenantGroupManager = TenantGroupManager;


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var resource_1 = __webpack_require__(0);
var TenantMenuManagerProvider = (function () {
    function TenantMenuManagerProvider() {
    }
    TenantMenuManagerProvider.prototype.$get = function (Client, Authorization, Tenant) {
        return new TenantMenuManager(Client, Authorization, Tenant);
    };
    ;
    return TenantMenuManagerProvider;
}());
exports.TenantMenuManagerProvider = TenantMenuManagerProvider;
var TenantMenuManager = (function (_super) {
    __extends(TenantMenuManager, _super);
    function TenantMenuManager(Client, Authorization, Tenant) {
        var _this = _super.call(this, Client) || this;
        _this.Authorization = Authorization;
        _this.Tenant = Tenant;
        return _this;
    }
    TenantMenuManager.prototype.getUrl = function (path) {
        if (!this.Authorization.IsAuthorized) {
            throw new Error('Not Authorized');
        }
        return "/api/account/" + this.Tenant.name + "/admin/menu" + path;
    };
    return TenantMenuManager;
}(resource_1.TenantResourceService));
exports.TenantMenuManager = TenantMenuManager;


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var resource_1 = __webpack_require__(0);
var TenantModuleManagerProvider = (function () {
    function TenantModuleManagerProvider() {
    }
    TenantModuleManagerProvider.prototype.$get = function (Client, Authorization, Tenant) {
        return new TenantModuleManager(Client, Authorization, Tenant);
    };
    ;
    return TenantModuleManagerProvider;
}());
exports.TenantModuleManagerProvider = TenantModuleManagerProvider;
var TenantModuleManager = (function (_super) {
    __extends(TenantModuleManager, _super);
    function TenantModuleManager(Client, Authorization, Tenant) {
        var _this = _super.call(this, Client) || this;
        _this.Authorization = Authorization;
        _this.Tenant = Tenant;
        return _this;
    }
    TenantModuleManager.prototype.getUrl = function (path) {
        if (!this.Authorization.IsAuthorized) {
            throw new Error('Not Authorized');
        }
        return "/api/account/" + this.Tenant.name + "/admin/module" + path;
    };
    return TenantModuleManager;
}(resource_1.TenantResourceService));
exports.TenantModuleManager = TenantModuleManager;


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var UserManagerProvider = (function () {
    function UserManagerProvider() {
    }
    UserManagerProvider.prototype.$get = function (Client, Authentication) {
        return new UserService(Client, Authentication);
    };
    ;
    return UserManagerProvider;
}());
exports.UserManagerProvider = UserManagerProvider;
var UserService = (function () {
    function UserService(Client, Authentication) {
        this.Client = Client;
        this.Authentication = Authentication;
    }
    UserService.prototype.getUrl = function (path) {
        return "/api/admin/user" + path;
    };
    UserService.prototype.query = function () {
        return this.Client.get(this.getUrl('/')).then(function (response) {
            return response.data.results;
        });
    };
    return UserService;
}());
exports.UserService = UserService;


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TelegramAuthenticatorProvider = (function () {
    function TelegramAuthenticatorProvider() {
    }
    TelegramAuthenticatorProvider.prototype.$get = function (Client) {
        return new TelegramAuthenticator(Client);
    };
    ;
    return TelegramAuthenticatorProvider;
}());
exports.TelegramAuthenticatorProvider = TelegramAuthenticatorProvider;
var TelegramAuthenticator = (function () {
    function TelegramAuthenticator(Client) {
        this.Client = Client;
    }
    TelegramAuthenticator.prototype.CreateToken = function () {
        return this.Client.post('/api/integration/telegram/auth/start')
            .then(function (response) { return response.data.result; });
    };
    TelegramAuthenticator.prototype.CheckToken = function (token) {
        return this.Client.post('/api/integration/telegram/auth/status', { token: token })
            .then(function (response) { return response.data.result; });
    };
    TelegramAuthenticator.prototype.AuthenticateToken = function (token) {
        return this.Client.post('/api/integration/telegram/auth/callback', { token: token })
            .then(function (response) { return response.data.result; });
    };
    return TelegramAuthenticator;
}());
exports.TelegramAuthenticator = TelegramAuthenticator;


/***/ })
/******/ ]);